- Main Page
- Modules
- Namespaces
- Classes
- Files

Functions
GLM_GTC_type_ptr: Memory layout access.
GTC Extensions (Stable)

Used to get a pointer to the memory layout of a basic type. More...

## Functions
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat2x2< T > | make_mat2 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat2x2< T > | make_mat2x2 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat2x3< T > | make_mat2x3 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat2x4< T > | make_mat2x4 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat3x3< T > | make_mat3 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat3x2< T > | make_mat3x2 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat3x3< T > | make_mat3x3 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat3x4< T > | make_mat3x4 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat4x4< T > | make_mat4 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat4x2< T > | make_mat4x2 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat4x3< T > | make_mat4x3 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tmat4x4< T > | make_mat4x4 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tvec2< T > | make_vec2 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tvec3< T > | make_vec3 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER detail::tvec4< T > | make_vec4 (T const *const ptr)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat4x4< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat4x3< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat4x3< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat3x4< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat3x4< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat4x2< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat2x4< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat2x4< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat2x2< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tvec3< T > &vec)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat3x3< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tvec2< T > &vec)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tvec2< T > const &vec)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tvec4< T > &vec)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat4x4< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat3x3< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat4x2< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat3x2< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T * | value_ptr (detail::tmat2x3< T > &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tvec3< T > const &vec)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tvec4< T > const &vec)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat3x2< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat2x3< T > const &mat)
template<typename T >
GLM_FUNC_QUALIFIER T const * | value_ptr (detail::tmat2x2< T > const &mat)

## Detailed Description

Used to get a pointer to the memory layout of a basic type.

This extension defines an overloaded function, glm::value_ptr, which takes any of the core template types. It returns a pointer to the memory layout of the object. Matrix types store their values in column-major order.

This is useful for uploading data to matrices or copying data to buffer objects.

Example:

    #include <glm/glm.hpp>
    #include <glm/gtc/type_ptr.hpp>

    glm::vec3 aVector(3);
    glm::mat4 someMatrix(1.0);

    glUniform3fv(uniformLoc, 1, glm::value_ptr(aVector));
    glUniformMatrix4fv(uniformMatrixLoc, 1, GL_FALSE, glm::value_ptr(someMatrix));

<glm/gtc/type_ptr.hpp> need to be included to use these functionalities.

## Function Documentation

GLM_FUNC_QUALIFIER detail::tmat2x2<T> glm::gtc::type_ptr::make_mat2 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 417 of file type_ptr.hpp.

References glm::gtc::type_ptr::make_mat2x2().

GLM_FUNC_QUALIFIER detail::tmat2x2<T> glm::gtc::type_ptr::make_mat2x2 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 326 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

Referenced by glm::gtc::type_ptr::make_mat2().

GLM_FUNC_QUALIFIER detail::tmat2x3<T> glm::gtc::type_ptr::make_mat2x3 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 336 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat2x4<T> glm::gtc::type_ptr::make_mat2x4 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 346 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat3x3<T> glm::gtc::type_ptr::make_mat3 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 425 of file type_ptr.hpp.

References glm::gtc::type_ptr::make_mat3x3().

GLM_FUNC_QUALIFIER detail::tmat3x2<T> glm::gtc::type_ptr::make_mat3x2 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 356 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat3x3<T> glm::gtc::type_ptr::make_mat3x3 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 366 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

Referenced by glm::gtc::type_ptr::make_mat3().

GLM_FUNC_QUALIFIER detail::tmat3x4<T> glm::gtc::type_ptr::make_mat3x4 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 376 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat4x4<T> glm::gtc::type_ptr::make_mat4 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 433 of file type_ptr.hpp.

References glm::gtc::type_ptr::make_mat4x4().

GLM_FUNC_QUALIFIER detail::tmat4x2<T> glm::gtc::type_ptr::make_mat4x2 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 387 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat4x3<T> glm::gtc::type_ptr::make_mat4x3 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 397 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tmat4x4<T> glm::gtc::type_ptr::make_mat4x4 | ( | T const *const | ptr | ) |

Build a matrix from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 407 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

Referenced by glm::gtc::type_ptr::make_mat4().

GLM_FUNC_QUALIFIER detail::tvec2<T> glm::gtc::type_ptr::make_vec2 | ( | T const *const | ptr | ) |

Build a vector from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 296 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tvec3<T> glm::gtc::type_ptr::make_vec3 | ( | T const *const | ptr | ) |

Build a vector from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 306 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER detail::tvec4<T> glm::gtc::type_ptr::make_vec4 | ( | T const *const | ptr | ) |

Build a vector from a pointer.

From GLM_GTC_type_ptr extension.

Definition at line 316 of file type_ptr.hpp.

References glm::gtc::type_ptr::value_ptr().

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x4< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 157 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x3< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 288 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x3< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 278 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x4< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 267 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x4< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 256 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x2< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 245 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x4< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 223 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x4< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 212 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x2< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 113 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tvec3< T > & | vec | ) |

Get the address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 69 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x3< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 124 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tvec2< T > & | vec | ) |

Get the address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 47 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tvec2< T > const & | vec | ) |

Get the const address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 36 of file type_ptr.hpp.

Referenced by glm::gtc::type_ptr::make_mat2x2(), glm::gtc::type_ptr::make_mat2x3(), glm::gtc::type_ptr::make_mat2x4(), glm::gtc::type_ptr::make_mat3x2(), glm::gtc::type_ptr::make_mat3x3(), glm::gtc::type_ptr::make_mat3x4(), glm::gtc::type_ptr::make_mat4x2(), glm::gtc::type_ptr::make_mat4x3(), glm::gtc::type_ptr::make_mat4x4(), glm::gtc::type_ptr::make_vec2(), glm::gtc::type_ptr::make_vec3(), and glm::gtc::type_ptr::make_vec4().

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tvec4< T > & | vec | ) |

Get the address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 91 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x4< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 146 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x3< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 135 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat4x2< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 234 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x2< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 201 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x3< T > & | mat | ) |

Get the address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 179 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tvec3< T > const & | vec | ) |

Get the const address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 58 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tvec4< T > const & | vec | ) |

Get the const address of the vector content.

From GLM_GTC_type_ptr extension.

Definition at line 80 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat3x2< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 190 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x3< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 168 of file type_ptr.hpp.

GLM_FUNC_QUALIFIER T const* glm::gtc::type_ptr::value_ptr | ( | detail::tmat2x2< T > const & | mat | ) |

Get the const address of the matrix content.

From GLM_GTC_type_ptr extension.

Definition at line 102 of file type_ptr.hpp.